#property indicator_chart_window
#property indicator_buffers 2
#property indicator_color1 Red 
#property indicator_color2 Blue

extern double FastLimit=0.5;
extern double SlowLimit=0.05;

double FAMABuffer[];
double MAMABuffer[];

int init()
  {
   string short_name;
   SetIndexStyle(0, DRAW_LINE);
   SetIndexStyle(1, DRAW_LINE);
   SetIndexBuffer(0, FAMABuffer);
   SetIndexBuffer(1, MAMABuffer);

//---- name for DataWindow and indicator subwindow label
   short_name="MAMA & FAMA";
   IndicatorShortName(short_name);
   SetIndexLabel(0,"FAMA");
   SetIndexLabel(1,"MAMA");
//----
   SetIndexDrawBegin(0,50);
   SetIndexDrawBegin(1,50);
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| #MAMA                                                            |
//+------------------------------------------------------------------+
int start()
  {
  if (Bars <= 5) return(0);
  int i, j, counted_bars = IndicatorCounted();

  double jI, jQ, DeltaPhase, alpha; 
  double Price[4], Smooth[7], Detrender[7], Q1[7], I1[7], I2[2], Q2[2];
  double Re[2], Im[2], SmoothPeriod[2], Period_[2], Phase[2], MAMA[2], FAMA[2];

  for (i = 6; i >= 0; i--)
  {
    Smooth[i] = 0;
    Detrender[i] = 0;
    Q1[i]=0;
    I1[i]=0;
  }

  for (i = 1; i >= 0; i--)
  {
    I2[i]=0;
    Q2[i]=0;
    Re[i]=0;
    Im[i]=0;
    SmoothPeriod[i]=0;
    Period_[i]=0;
    Phase[i]=0;
    MAMA[i]=0;
    FAMA[i]=0;
  }


  for (i = (Bars - counted_bars) + 5; i >= 0; i--)
  { 
    Price[0]=((High[i] + Low[i])/2); 
    Price[1]=((High[i+1] + Low[i+1])/2); 
    Price[2]=((High[i+2] + Low[i+2])/2);
    Price[3]=((High[i+3] + Low[i+3])/2); 

    Smooth[0] = (4*Price[0] + 3*Price[1] + 2*Price[2] + Price[3])/ 10; 
    Detrender[0] = (0.0962*Smooth[0] + 0.5769*Smooth[2] - 0.5769*Smooth[4] - 0.0962*Smooth[6])*(0.075*Period_[1] + 0.54); 

// {Compute InPhase and Quadrature components} 
    Q1[0] = (0.0962*Detrender[0] + 0.5769*Detrender[2] - 0.5769*Detrender[4] - 0.0962*Detrender[6])*(0.075*Period_[1] + 0.54); 
    I1[0] = Detrender[3]; 

// {Advance the phase of I1 and Q1 by 90 degrees} 
    jI = (0.0962*I1[0] + 0.5769*I1[2] - 0.5769*I1[4] - 0.0962*I1[6])*(0.075*Period_[1] + 0.54); 
    jQ = (0.0962*Q1[0] + 0.5769*Q1[2] - 0.5769*Q1[4] - 0.0962*Q1[6])*(0.075*Period_[1] + 0.54); 

// {Phasor addition for 3 bar averaging)} 
    I2[0] = I1[0] - jQ; 
    Q2[0] = Q1[0] + jI; 

// {Smooth the I and Q components before applying the discriminator} 
    I2[0] = 0.2*I2[0] + 0.8*I2[1]; 
    Q2[0] = 0.2*Q2[0] + 0.8*Q2[1]; 

// {Homodyne Discriminator} 
   Re[0] = I2[0]*I2[1] + Q2[0]*Q2[1]; 
   Im[0] = I2[0]*Q2[1] - Q2[0]*I2[1]; 
   
   Re[0] = 0.2*Re[0] + 0.8*Re[1]; 
   Im[0] = 0.2*Im[0] + 0.8*Im[1]; 

   if (Im[0] != 0 && Re[0] != 0) 
      Period_[0] = 360/MathArctan(Im[0]/Re[0]); 
   if (Period_[0] > 1.5*Period_[1])
      Period_[0] = 1.5*Period_[1]; 
   if (Period_[0] < 0.67*Period_[1])
      Period_[0] = 0.67*Period_[1]; 
   if (Period_[0] < 6) 
      Period_[0] = 6; 
   if (Period_[0] > 50) 
      Period_[0] = 50; 
   
   Period_[0] = 0.2*Period_[0] + 0.8*Period_[1]; 
   SmoothPeriod[0] =0.33*Period_[0] + 0.67*SmoothPeriod[1]; 

   if (I1[0] != 0) 
      Phase[0] = (MathArctan(Q1[0] / I1[0])); 
   DeltaPhase = Phase[1] - Phase[0]; 
   if (DeltaPhase < 1) 
     DeltaPhase = 1; 
   alpha = FastLimit / DeltaPhase; 
   if (alpha < SlowLimit) alpha = SlowLimit; 
   MAMA[0] = alpha*Price[0] + (1 - alpha)*MAMA[1]; 
   FAMA[0] = 0.5*alpha*MAMA[0] + (1 - 0.5*alpha)*FAMA[1]; 

   FAMABuffer[i] = MAMA[0];
   MAMABuffer[i] = FAMA[0];

   Smooth[6] = Smooth[5];
   Smooth[5] = Smooth[4];
   Smooth[4] = Smooth[3];
   Smooth[3] = Smooth[2];
   Smooth[2] = Smooth[1]; 
   Smooth[1] = Smooth[0];

   Detrender[6] = Detrender[5];
   Detrender[5] = Detrender[4];
   Detrender[4] = Detrender[3];
   Detrender[3] = Detrender[2];
   Detrender[2] = Detrender[1]; 
   Detrender[1] = Detrender[0]; 

   Q1[6] = Q1[5];
   Q1[5] = Q1[4];
   Q1[4] = Q1[3];
   Q1[3] = Q1[2];
   Q1[2] = Q1[1]; 
   Q1[1] = Q1[0]; 

   I1[6] = I1[5];
   I1[5] = I1[4];
   I1[4] = I1[3];
   I1[3] = I1[2];
   I1[2] = I1[1]; 
   I1[1] = I1[0]; 


   Q2[1]=Q2[0]; 
   I2[1]=I2[0]; 
   Re[1]=Re[0]; 
   Im[1]=Im[0]; 
   
   SmoothPeriod[1] = SmoothPeriod[0]; 
   Phase[1] = Phase[0]; 
   Period_[1] = Period_[0]; 
   MAMA[1] = MAMA[0]; 
   FAMA[1] = FAMA[0]; 
  }
  return(0);
}

